//Ф-ция подключает обработчик события funcName эл-та element к событию eventName
function addEventListenerHandle(element, eventName, funcName){
	try{
		element.addEventListener(eventName, funcName, false);
	}catch(e){
		element.attachEvent("on" + eventName, funcName);
	}
}

//Ф-ция возвращает элемент, к-рый инициировал событие
function getThis(eventObj){
	eventObj = eventObj || event;
	return eventObj.target || eventObj.srcElement;
}

//Ф-ция возвращает элемент по значению атрибута class
function getElementsByClass(allElements, className){
	for(var i = allElements.length - 1; i >= 0; i--){
		if(allElements[i].getAttribute("class") === className)
			return allElements[i];
	}
}

//Ф-ция убирает единыцы измерения: 10px вернет как 10
function withoutMark(value, mark){
	var lastIndex = value.lastIndexOf(mark);
	var resultat = value.slice(0, lastIndex);
	return resultat;
}

//Ф-ция возвращает текущее стилевое правило style для эл-та element. При необходимости
//можем убрать единицы измерения
function getCurRuleStyle(element, style, mark){
	var resultat;
	if(window.getComputedStyle)
		resultat = getComputedStyle(element, null)[style];
	else
		resultat = element.currentStyle[style];
	if(mark)
		return withoutMark(resultat, mark);
	else
		return resultat;
}

//Ф-ция создает метод myinput для эл-та DIV. Данный метод отвечает за специфически оформленный эл-т input
function createMyInputElements(){
	var myInputObject = new Object(
		this.width, //Общая ширина эл-та my-input
		this.topTitleDefault, //начальное положение надписи типа Логин, Пароль и т.д.
		this.topTitleMax, //конечное положение надписи типа Логин, Пароль и т.д.
		this.borderColor, //цвет рамки эл-та my-input
		this.spanColor, //цвет шрифта надписи типа Логин, Пароль и т.д.
		this.divBottomBG, //цвет индикатора активации эл-та my-input
		this.textColor, //цвет шрифта эл-та my-input
		this.delay //задержка срабатывания после пападания курсора на эл-т my-input
	);

	function createMyInput(myInputObject){
		this.style.width = ((myInputObject.width) || getCurRuleStyle(this, "width", "px")) + "px";
		this.style.borderColor = myInputObject.borderColor || getCurRuleStyle(this, "borderColor");

		var	mySpan = this.getElementsByTagName("SPAN")[0];
		var	maxTop = myInputObject.topTitleMax || getCurRuleStyle(mySpan, "top", "px") * 1;
		mySpan.style.top = ((myInputObject.topTitleDefault) || 10) + "px";
		mySpan.style.color = myInputObject.spanColor || getCurRuleStyle(mySpan, "color");

		var	myInput = this.getElementsByTagName("INPUT")[0];
		myInput.style.color = myInputObject.textColor || getCurRuleStyle(myInput, "color");

		var	divBottom = this.getElementsByTagName("DIV")[0];
		divBottom.style.width = "0";
		divBottom.style.background = myInputObject.divBottomBG || getCurRuleStyle(divBottom, "backgroundColor");

		var	maxWidth = this.clientWidth;
		var	curWidth = 0;
		var	curTop = mySpan.offsetTop;
		var	step = 20;
		var	widthDelta = maxWidth / step;
		var	topDelta = (maxTop - curTop) / step;
		var	active;
		var	timer, delay = myInputObject.delay || 0;
		var timeOver, timeOut, deltaTime;

		function dinamicsEffects(){
			curWidth += widthDelta;
			if(curWidth < maxWidth){
				divBottom.style.width = curWidth + "px";
				curTop += topDelta;
				mySpan.style.top = curTop + "px";
			}else{
				divBottom.style.width = maxWidth + "px";
				mySpan.style.top = maxTop + "px";
				clearInterval(timer);
				//timer = null;
				active = true;
			}
		}
		function goDinamicsEffects(){
			timer = setInterval(dinamicsEffects, 5);
		}
		function thisOnmouseoverHandle(evt){
			if(!active){
				timeOver = new Date();
				timer = setTimeout(goDinamicsEffects, delay);
			}
		}
		function thisOnmouseoutHandle(){
			if(!active){
				timeOut = new Date();
				deltaTime = timeOut - timeOver;
				if (deltaTime < delay){
					clearTimeout(timer);
					//timer = null;
				}
			}
		}

		addEventListenerHandle(this, "mouseover", thisOnmouseoverHandle);
		addEventListenerHandle(this, "mouseout", thisOnmouseoutHandle);
		
		//return this //Возвращаем ссылку на сам блок div, в к-ром содержится эл-т my-input 
	}

	var myDiv = document.getElementsByTagName("DIV")[0];
	myDiv.constructor.prototype.myinput = createMyInput;
}

//Ф-ция создает метод myselect для эл-та DIV. Данный метод отвечает за специфически оформленный эл-т select
function createMySelectElements(){
	var mySelectObject = new Object(
		this.width, //Общая ширина эл-та my-select
		this.borderColor, //цвет рамки эл-та my-select
		this.textColor, //цвет шрифта эл-та my-select
		this.optionSectionBG //цвет фона секции с вариантами выбора
	);
	var zIndex = 100000;

	function createMySelect(mySelectObject){
		var selectedLi = getElementsByClass(this.getElementsByTagName("LI"), "my-select-selected");
		var fieldSelect = this.getElementsByTagName("DT")[0];
		var optionSection = this.getElementsByTagName("DD")[0];
		var allSpans = this.getElementsByTagName("SPAN");
		for(var i = 0; i < allSpans.length; i++){
			if(allSpans[i].getAttribute("class") === "my-select-tr")
				allSpans[i].style.borderTopColor = mySelectObject.borderColor || getCurRuleStyle(allSpans[i], "borderTopColor");
		}

		this.style.width = (mySelectObject.width || getCurRuleStyle(this, "width", "px")) + "px";
		this.style.color = mySelectObject.textColor || getCurRuleStyle(this, "color");

		fieldSelect.style.borderColor = optionSection.style.borderBottomColor =
		mySelectObject.borderColor || getCurRuleStyle(fieldSelect, "borderColor");

		optionSection.style.backgroundColor = mySelectObject.optionSectionBG || getCurRuleStyle(optionSection, "backgroundColor");
		optionSection.style.zIndex = ++zIndex;

		if(selectedLi){
			var curLink = selectedLi.getElementsByTagName("A")[0];
			fieldSelect.innerHTML = curLink.innerHTML;
		}

		function thisClickHandle(evt){
			target = getThis(evt);
			if(target.parentNode.getAttribute("class") != "my-select-disabled"){
				var ruleDisplay = getCurRuleStyle(optionSection, "display");
				if(ruleDisplay === "none"){
					optionSection.style.display = "block";
				}else
					optionSection.style.display = "";
				if(target.tagName === "A"){
					fieldSelect.innerHTML = target.innerHTML;
				}
			}
		}

		addEventListenerHandle(this, "click", thisClickHandle);
		
		//return this //Возвращаем ссылку на сам блок div, в к-ром содержится эл-т my-select 
	}

	var myDiv = document.getElementsByTagName("DIV")[0];
	myDiv.constructor.prototype.myselect = createMySelect;
}

//Ф-ция создает метод mychecbox для эл-та DIV. Данный метод отвечает за специфически оформленный эл-т checbox
function createMyCheckboxElements(){
	var myIcons = {
		_default: "-1px",
		blue: "-15px",
		red: "-29px"
	};
	var myCheckboxObject = new Object(
		this.borderColor, //цвет рамки эл-та checkbox
		this.iconName, //задает иконку эл-та checkbox
		this.textColor, //цвет шрифта эл-та checkbox
		this.verticalAlign //расположение по вертикали эл-та, к-рый выводит пользовательское соглашение
	);

	function createMyCheckbox(myCheckboxObject){
		var allDivs = this.getElementsByTagName("DIV");
		var divCheckboxIcon = getElementsByClass(allDivs, "my-checkbox-icon");
		var spanLoadDoc = getElementsByClass(this.getElementsByTagName("SPAN"), "my-checkbox-loaddoc");
		var divDoc = getElementsByClass(allDivs, "my-checkbox-doc");
		var divAgreement = getElementsByClass(allDivs, "my-checkbox-agreement");

		divCheckboxIcon.style.borderColor = myCheckboxObject.borderColor || getCurRuleStyle(divCheckboxIcon, "borderColor");

		var divIconName = myIcons[myCheckboxObject.iconName] || myIcons._default;
		divCheckboxIcon.style.backgroundPosition = divIconName + " -1px";

		divAgreement.style.color = myCheckboxObject.textColor || getCurRuleStyle(this, "color");

		function divCheckboxIconClickHandle(){
			if(getCurRuleStyle(divCheckboxIcon, "backgroundImage") === "none")
				divCheckboxIcon.style.backgroundImage = "url('img/myicons.png')";
			else
				divCheckboxIcon.style.backgroundImage = "none";
		}
		function spanLoadDocClickHandle(evt){
			if(getCurRuleStyle(divDoc, "display") === "none"){
				var htmlElm = document.documentElement;
				var htmlElmWidth = htmlElm.clientWidth;
				var divDocWidth = getCurRuleStyle(divDoc, "width", "px") * 1;
				switch(myCheckboxObject.verticalAlign){
					case "bottom": divDoc.style.bottom = "0"; break;
					case "top": divDoc.style.top = "0"; break;
					default: {
						var htmlElmHeight = htmlElm.clientHeight;
						var divDocHeight = getCurRuleStyle(divDoc, "height", "px") * 1;
						divDoc.style.top = ((htmlElmHeight - divDocHeight) / 2) + "px";
					}
				}
				divDoc.style.left = ((htmlElmWidth - divDocWidth) / 2) + "px";
				divDoc.style.display = "block";
				document.body.appendChild(divDoc);
			}
		}
		function divDocClickHandle(){
			divDoc.style.display = "";
		}

		addEventListenerHandle(divCheckboxIcon, "click", divCheckboxIconClickHandle);
		addEventListenerHandle(spanLoadDoc, "click", spanLoadDocClickHandle);
		addEventListenerHandle(divDoc, "click", divDocClickHandle);
		
		//return this //Возвращаем ссылку на сам блок div, в к-ром содержится эл-т my-checkbox 
	}

	var myDiv = document.getElementsByTagName("DIV")[0];
	myDiv.constructor.prototype.mycheckbox = createMyCheckbox;
}

//Ф-ция создает метод myradio для эл-та DIV. Данный метод отвечает за специфически оформленный эл-т radio
function createMyRadioElements(){
	var myIcons = {
		_default: "0",
		blue: "-14px",
		red: "-28px"
	};
	var myRadioObject = new Object(
		this.iconName, //задает иконку эл-та checkbox
		this.textColor //цвет шрифта эл-та checkbox
	);

	var lastSelected;
	function createMyRadio(myRadioObject){
		var divRadioIcon = this.getElementsByTagName("DIV")[0];
		var iconTop;
		var iconLeft = myIcons[myRadioObject.iconName] || myIcons._default;
		if(this.getAttribute("class").lastIndexOf("my-radio-selected") >= 0){
			iconTop = " -28px";
			divRadioIcon.selected = true;
			lastSelected = divRadioIcon;
		}else{
			iconTop = " -14px";
		}
		divRadioIcon.style.backgroundPosition = iconLeft + iconTop;

		this.style.color = myRadioObject.textColor || getCurRuleStyle(this, "color");

		function setRadioboxParams(divIcon, topVal, selected, classValue){
			var className;
			divIcon.style.backgroundPosition = iconLeft + " " + topVal;
			divIcon.selected = selected;
			className = divIcon.parentNode.getAttribute("class");
			if(selected)
				divIcon.parentNode.setAttribute("class", className + " " + classValue);
			else
				divIcon.parentNode.setAttribute("class", withoutMark(className, " " + classValue));
		}
		function thisClickHandle(){
			if(!divRadioIcon.selected){
				if(lastSelected)
					setRadioboxParams(lastSelected, "-14px", false, "my-radio-selected");
				setRadioboxParams(divRadioIcon, "-28px", true, "my-radio-selected");
				lastSelected = divRadioIcon;
			}
		}

		addEventListenerHandle(this, "click", thisClickHandle);
	}

	var myDiv = document.getElementsByTagName("DIV")[0];
	myDiv.constructor.prototype.myradio = createMyRadio;
}

//В момент загрузки страницы запускает ф-ции создания my-элементов
function windowOnloadMyElements(){
	createMyInputElements();
	createMySelectElements();
	createMyCheckboxElements();
	createMyRadioElements();
}
